/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// AWSClusterStaticIdentityLister helps list AWSClusterStaticIdentities.
// All objects returned here must be treated as read-only.
type AWSClusterStaticIdentityLister interface {
	// List lists all AWSClusterStaticIdentities in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSClusterStaticIdentity, err error)
	// Get retrieves the AWSClusterStaticIdentity from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta2.AWSClusterStaticIdentity, error)
	AWSClusterStaticIdentityListerExpansion
}

// aWSClusterStaticIdentityLister implements the AWSClusterStaticIdentityLister interface.
type aWSClusterStaticIdentityLister struct {
	indexer cache.Indexer
}

// NewAWSClusterStaticIdentityLister returns a new AWSClusterStaticIdentityLister.
func NewAWSClusterStaticIdentityLister(indexer cache.Indexer) AWSClusterStaticIdentityLister {
	return &aWSClusterStaticIdentityLister{indexer: indexer}
}

// List lists all AWSClusterStaticIdentities in the indexer.
func (s *aWSClusterStaticIdentityLister) List(selector labels.Selector) (ret []*v1beta2.AWSClusterStaticIdentity, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSClusterStaticIdentity))
	})
	return ret, err
}

// Get retrieves the AWSClusterStaticIdentity from the index for a given name.
func (s *aWSClusterStaticIdentityLister) Get(name string) (*v1beta2.AWSClusterStaticIdentity, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta2.Resource("awsclusterstaticidentity"), name)
	}
	return obj.(*v1beta2.AWSClusterStaticIdentity), nil
}
